;=========================================================================
;
; Liaisons avec EXCEL V5.02
;
; (C) Patrick_35
;
;=========================================================================

;=========================================================================
; Supprimer les racteurs
;=========================================================================

(defun patrick:effacer_le_reacteur_lxl(/ i j n)
  (if (setq i (vlr-reactors :vlr-acdb-reactor))
    (progn
      (setq n 1 i (nth n (car i)))
      (while i
        (setq j nil)
        (if (eq (cdr (car (vlr-reactions i))) 'PATRICK:REACTEUR_LXL)
          (setq j i)
        )
        (if j
          (vlr-remove j)
          (setq n (1+ n))
        )
        (if (setq i (vlr-reactors :vlr-acdb-reactor))
          (setq i (nth n (car i)))
        )
      )
    )
  )
  (if (setq i (vlr-reactors :vlr-command-reactor))
    (progn
      (setq n 1 i (nth n (car i)))
      (while i
        (setq j nil)
        (if (eq (cdr (car (vlr-reactions i))) 'PATRICK:ANNULER_ADCENTER)
          (setq j i)
        )
        (if j
          (vlr-remove j)
          (setq n (1+ n))
        )
        (if (setq i (vlr-reactors :vlr-command-reactor))
          (setq i (nth n (car i)))
        )
      )
    )
  )
  T
)

;=========================================================================
; Pointer sur la commande en cours
;=========================================================================

(defun patrick:annuler_adcenter(rea cde)
  (setq old_intervenir_une_fois intervenir_une_fois
	intervenir_une_fois (car cde)
  )
)

;=========================================================================
; Racteur pour nouveau lment rferenc avec LXL
;=========================================================================

(defun patrick:reacteur_lxl(rea data /	att ent lancer lst n rep sel txt
					dechex inc_suff inputBox selection_cellule incrementation_auto)

;-------------------------------------------------------------------------
; Saisir une valeur via une boite de dialogue
;-------------------------------------------------------------------------

  ;; InputBox (gile)
  ;; Ouvre une boite de dialogue pour rcuprer une valeur
  ;; sous forme de chaine de caractre
  ;;
  ;; Arguments
  ;; tous les arguments sont de chaines de caractre (ou "")
  ;; box : titre de la boite de dialogue
  ;; msg : message d'invite
  ;; val : valeur par dfaut
  ;;
  ;; Retour
  ;; une chaine ("" si annulation)
  ;;
  ;; Modifi par Patrick_35 pour inclure le caractre \n
  ;; comme retour chariot

  (defun InputBox (box msg val / subr temp file dcl_id ret)
    ;; Retour chariot automatique  50 caractres
    (defun subr (str / pos)
      (cond
	((setq pos (vl-string-search "\n" str))
	  (strcat ":text_part{label=\""
		  (substr str 1 pos)
		  "\";}"
		  (subr (substr str (+ 2 pos)))
	  )
	)
	((and (< 80 (strlen str))
	      (setq pos (vl-string-position 32 (substr str 1 80) nil T))
	  )
	  (strcat ":text_part{label=\""
		  (substr str 1 pos)
		  "\";}"
		  (subr (substr str (+ 2 pos)))
	  )
	)
	(T
	  (strcat ":text_part{label=\"" str "\";}")
	)
      )
    )
    ;; Crer un fichier DCL temporaire
    (setq temp (vl-filename-mktemp "Tmp.dcl")
	  file (open temp "w")
	  ret  ""
    )
    ;; Ecrire le fichier
    (write-line
      (strcat
	"InputBox:dialog{key=\"box\";initial_focus=\"val\";spacer;:paragraph{"
	(subr msg)
	"}spacer;:edit_box{key=\"val\";edit_width=54;allow_accept=true;}
	spacer;ok_cancel;}"
      )
      file
    )
    (close file)
    ;; Ouvrir la boite de dialogue
    (setq dcl_id (load_dialog temp))
    (if (not (new_dialog "InputBox" dcl_id))	
      (exit)
    )
    (set_tile "box" box)
    (set_tile "val" val)
    (action_tile
      "accept"
      "(setq ret (get_tile \"val\")) (done_dialog)"
    )
    (start_dialog)
    (unload_dialog dcl_id)
    ;;Supprimer le fichier
    (vl-file-delete temp)
    ret
  )

;-------------------------------------------------------------------------
; Convertir un chiffre dcimal en hxa
;-------------------------------------------------------------------------

  (defun dechex (nb / r i)
    (setq r "")
    (while (and (= (type nb) 'INT) (> nb 0))
      (setq i (rem nb 16))
      (setq nb (lsh nb -4))
      (setq r (strcat (if (< i 10)
			(itoa i)
			(chr (+ 55 i ))
		      ) r))
    )
  )

;-------------------------------------------------------------------------
; Slectionner une cellule Excel
;-------------------------------------------------------------------------

  (defun selection_cellule(def msg ok / rep)
    (while (vl-string-search "\"" msg)
      (setq msg (vl-string-subst "" "\"" msg))
    )
    (if (eq (setq rep (inputbox "LXL" (strcat "Veuillez indiquer la rfrence de la cellule\nExemple : A10" msg) def)) "")
      nil
      (progn
	(if (and (or (and (> (vl-string-elt rep 0) 64)(< (vl-string-elt rep 0) 91))
		     (and (> (vl-string-elt rep 0) 96)(< (vl-string-elt rep 0) 123)))
	    (and	  (> (vl-string-elt rep (1- (strlen rep))) 47)(< (vl-string-elt rep (1- (strlen rep))) 58)))
	  rep
	  (progn
	    (if ok
	      (princ (strcat "\nLa valeur \"" rep "\" est incorrecte.\nElle ne correspond pas  une rfrence de cellule Excel."))
	      (msgbox "LXL" 48 (strcat "\nLa valeur \"" rep "\" est incorrecte.\nElle ne correspond pas  une rfrence de cellule Excel."))
	    )
	    nil
	  )
	)
      )
    )
  )

;-------------------------------------------------------------------------
; Incrmenter un texte de +1
;-------------------------------------------------------------------------

;; INCSUFF - Gilles Chanteau - 15/01/08
;; Incrmente le suffixe d'une chane de caractres de la valeur spcifie.
;; Est pris en compte comme suffixe, l'ensemble des caractres [0-9] depuis
;; la fin de la chane ainsi que les caractres [A-Z] et [a-z] si alpha est non nil
;;
;; Arguments
;; str : une chane avec un suffixe valide
;; inc : un entier positif
;; alpha : si non nil, les caractres [a-z] [A-Z] sont intgrs au suffixe
;;
;; Retour
;; la chane avec son suffixe incrment (ou nil si aucun suffixe valide)
;;
;; Exemples :
;; (incsuff "N002" 12 T) = "N014"
;; (incsuff "test_ZZ9" 1 T) = "test_AAA0"
;; (incsuff "test_ZZ9" 1 nil) = "test_ZZ10"
;; (incsuff "12-" 1 nil) = nil

  (defun incsuff (str inc alpha / lst crt pas ind dep quo ret)
    (setq lst (reverse (vl-string->list str)))
    (while
      (and
	(setq crt (car lst))
	(cond
	  ((< 47 crt 58)
	    (setq pas 10
		  ind 48
	    )
	  )
	  ((and alpha (< 64 crt 91))
	    (setq pas 26
		  ind 65
	    )
	  )
	  ((and alpha (< 96 crt 123))
	    (setq pas 26
		  ind 97
	    )
	  )
	  ((< 0 quo)
	    (setq crt (if (= 10 pas)
			ind
			(1- ind)
		      )
		  lst (cons (car lst) lst)
	    )
	  )
	)
      )
      (setq dep (- crt ind)
	    quo (/ (+ dep inc) pas)
	    ret (cons (+ ind (rem (+ dep inc) pas)) ret)
      )
      (if (zerop quo)
	(setq ret (append (reverse (cdr lst)) ret)
	      lst nil
	)
	(if (cdr lst)
	  (setq lst (cdr lst)
		inc quo
	  )
	  (setq lst (list ind)
		inc (if (= 10 pas)
		      quo
		      (1- quo)
		    )
	  )
	)
      )
    )
    (if ret
      (vl-list->string ret)
    )
  )

;-------------------------------------------------------------------------
; Incrmentation automatique des cellules
;-------------------------------------------------------------------------

  (defun incrementation_auto(lst sel / deb fin rep saut)
    (if (setq rep (selection_cellule "" "" T))
      (progn
	(if (or (and (> (vl-string-elt rep 1) 64) (< (vl-string-elt rep 1) 91))
		(and (> (vl-string-elt rep 1) 96) (< (vl-string-elt rep 1) 123)))
	  (setq deb (substr rep 1 2) fin (atoi (substr rep 3)))
	  (setq deb (substr rep 1 1) fin (atoi (substr rep 2)))
	)
	(setq lst (append lst (mapcar '(lambda (x) (if (not saut)
						     (setq saut T)
						     (if (eq position_saisie_excel 2)
						       (setq fin (1+ fin))
						       (setq deb (incsuff deb 1 T))
						     )
						   )
						   (cons x (strcat deb (itoa fin))))
				      sel)))
      )
    )
  )

  (if (or (member intervenir_une_fois (list nil "ADCENTER" "ACDCATTEDIT" "ERASE"))
	  (and (eq intervenir_une_fois "DROPGEOM")
	       (eq old_intervenir_une_fois "ACDCINSERTBLOCK")
	  )
      )
   (setq lancer nil)
   (setq lancer T)
  )
  (and lancer
    (setq ent (vlax-ename->vla-object (cadr data)))
    (eq (vla-get-objectname ent) "AcDbSequenceEnd")
    (member (vla-get-name (vla-objectidtoobject (vla-get-database ent)(vla-get-ownerid ent)))(vlax-ldata-get (strcat (vlr-data rea) "_params") "Params"))
    (progn
      (setq sel (vlax-invoke (vla-objectidtoobject (vla-get-database ent)(vla-get-ownerid ent)) 'getattributes))
      (if (eq position_saisie_excel 1)
	(foreach att sel
	  (setq txt (strcat "\nBloc : " (vla-get-name (vla-objectidtoobject (vla-get-database att)(vla-get-ownerid att)))
			    "\nEtiquette : " (vla-get-tagstring att)
			    "\nValeur Attribut : " (vla-get-textstring att)
			    "\nID : " (strcase (dechex (vla-get-objectid att)) T)))
	  (if (setq rep (selection_cellule "" txt T))
	    (setq lst (append lst (list (cons att rep))))
	    (setq lst (append lst (list (cons att "A1"))))
	  )
	)
	(setq lst (incrementation_auto lst sel))
      )
    )
  )
  (if lst
    (progn
      (setq sel (list (car (vlax-ldata-get (vlr-data rea) position_fichier_excel))) n 1)
      (while (setq att (nth n (vlax-ldata-get (vlr-data rea) position_fichier_excel)))
	(if (eq (atoi position_feuille_excel) (1- n)) 
	  (setq sel (append sel (list (cons (car att) (append (cdr att) lst)))))
	  (setq sel (append sel (list att)))
	)
	(setq n (1+ n))
      )
      (vlax-ldata-put (vlr-data rea) position_fichier_excel sel)
    )
  )
)

;=========================================================================
; Routine LXL
;=========================================================================

(defun c:lxl(/ 	classeur cle lst_err lxl_dia liste_fichiers_ouvert res wks xl xls
		affiche_attribut affiche_attributs affiche_fichier ajouter_attributs
		ajouter_feuille ajouter_fichier changer_feuille changer_fichier
		choix_feuille data_ok dechex erreur_fichier fermer_excel gestion_affichage_boite
		haut_bas incrementation_auto incsuff inputbox lancer_excel liste_feuilles
		liste_fichiers mise_a_jour modifier_attributs msgbox position_attribut
		position_feuille position_fichier rechercher_data recherche_valeur
		trier_attributs_haut trier_attributs_bas selection_cellule
		supprimer_attribut supprimer_feuille supprimer_fichier UnFormat
		verifier_att verifier_excel
		changer_attributs selection_blocs rechercher_data_lxl
		changer_feuille_att affiche_changer trier_attributs affiche_trier)

;-------------------------------------------------------------------------
; Afficher un message via une boite de dialogue
;-------------------------------------------------------------------------

  (defun MsgBox (Titre Bouttons Message / Reponse WshShell)
    (acad-push-dbmod)
    (setq WshShell (vlax-create-object "WScript.Shell"))
    (setq Reponse (vlax-invoke WshShell 'Popup Message 0 Titre (itoa Bouttons)))
    (vlax-release-object WshShell)
    (acad-pop-dbmod)
    Reponse
  )

;-------------------------------------------------------------------------
; Saisir une valeur via une boite de dialogue
;-------------------------------------------------------------------------

  ;; InputBox (gile)
  ;; Ouvre une boite de dialogue pour rcuprer une valeur
  ;; sous forme de chaine de caractre
  ;;
  ;; Arguments
  ;; tous les arguments sont de chaines de caractre (ou "")
  ;; box : titre de la boite de dialogue
  ;; msg : message d'invite
  ;; val : valeur par dfaut
  ;;
  ;; Retour
  ;; une chaine ("" si annulation)
  ;;
  ;; Modifi par Patrick_35 pour inclure le caractre \n
  ;; comme retour chariot

  (defun InputBox (box msg val / subr temp file dcl_id ret)
    ;; Retour chariot automatique  50 caractres
    (defun subr (str / pos)
      (cond
	((setq pos (vl-string-search "\n" str))
	  (strcat ":text_part{label=\""
		  (substr str 1 pos)
		  "\";}"
		  (subr (substr str (+ 2 pos)))
	  )
	)
	((and (< 80 (strlen str))
	      (setq pos (vl-string-position 32 (substr str 1 80) nil T))
	  )
	  (strcat ":text_part{label=\""
		  (substr str 1 pos)
		  "\";}"
		  (subr (substr str (+ 2 pos)))
	  )
	)
	(T
	  (strcat ":text_part{label=\"" str "\";}")
	)
      )
    )
    ;; Crer un fichier DCL temporaire
    (setq temp (vl-filename-mktemp "Tmp.dcl")
	  file (open temp "w")
	  ret  ""
    )
    ;; Ecrire le fichier
    (write-line
      (strcat
	"InputBox:dialog{key=\"box\";initial_focus=\"val\";spacer;:paragraph{"
	(subr msg)
	"}spacer;:edit_box{key=\"val\";edit_width=54;allow_accept=true;}
	spacer;ok_cancel;}"
      )
      file
    )
    (close file)
    ;; Ouvrir la boite de dialogue
    (setq dcl_id (load_dialog temp))
    (if (not (new_dialog "InputBox" dcl_id))	
      (exit)
    )
    (set_tile "box" box)
    (set_tile "val" val)
    (action_tile
      "accept"
      "(setq ret (get_tile \"val\")) (done_dialog)"
    )
    (start_dialog)
    (unload_dialog dcl_id)
    ;;Supprimer le fichier
    (vl-file-delete temp)
    ret
  )

;-------------------------------------------------------------------------
; Lancer une liaison avec Excel
;-------------------------------------------------------------------------

  (defun lancer_excel(/ sel)
    (setq xl  (vlax-get-or-create-object "Excel.Application"))
    (setq wks (vlax-get xl 'Workbooks))
    (vlax-for sel wks
      (setq liste_fichiers_ouvert (append liste_fichiers_ouvert (list (strcase (vlax-get sel 'fullname)))))
    )
  )

;-------------------------------------------------------------------------
; Selectionner une feuille Excel
;-------------------------------------------------------------------------

  (defun choix_feuille(cla / feu pos res)
    (setq res 0)
    (new_dialog "lxl" lxl_dia "")
    (start_list "feuille")
    (vlax-for feu cla
      (add_list (vlax-get feu 'name))
      (if (eq (vlax-get feu 'name) (vlax-get (vlax-get (vlax-get cla 'parent) 'activesheet) 'name))
	(setq pos (itoa res))
      )
      (setq res (1+ res))
    )
    (end_list)
    (set_tile "feuille" pos)
    (mode_tile "feuille" 2)
    (action_tile "feuille" "(setq pos $value)")
    (action_tile "accept"  "(done_dialog 1)")
    (action_tile "cancel"  "(done_dialog 0)")
    (setq res (start_dialog))
    (if (eq res 1)
      (setq feu (vlax-get (vlax-get-property cla 'item (1+ (atoi pos))) 'name))
    )
    feu
  )

;-------------------------------------------------------------------------
; Fermer la liaison avec Excel
;-------------------------------------------------------------------------

  (defun fermer_excel(/ ok sel)
    (if (not (member (strcase (vlax-get xls 'fullname)) liste_fichiers_ouvert))
      (vlax-invoke-method xls 'close :vlax-false)
    )
    (foreach sel (list xl wks xls classeur)
      (vlax-release-object sel)
    )
    (setq xl nil wks nil xls nil classeur nil)
    (gc)(gc)
  )

;-------------------------------------------------------------------------
; Convertir un chiffre dcimal en hxa
;-------------------------------------------------------------------------

  (defun dechex (nb / r i)
    (setq r "")
    (while (and (= (type nb) 'INT) (> nb 0))
      (setq i (rem nb 16))
      (setq nb (lsh nb -4))
      (setq r (strcat (if (< i 10)
			(itoa i)
			(chr (+ 55 i ))
		      ) r))
    )
  )

;-------------------------------------------------------------------------
; Rcuperer la valeur String d'un Mtext
; Extrait du lisp de Custom Stuff StripMtext v3.07
; http://www.users.qwest.net/~sdoman/
;-------------------------------------------------------------------------

  (defun UnFormat (Mtext Formats / All Format1 Format2 Format3 Pos Text Str)
    (and
      Mtext
      Formats
      (= (type Mtext) 'STR)
      (= (type Formats) 'STR)
      (setq Formats (strcase Formats))
      (setq Text "")
      (setq All T)
      (if (= Formats "*")
	(setq Formats "S"
	      Format1 "\\[LO`~]"
	      Format2 "\\[ACFHQTW]"
	      Format3 "\\P"
	)
	(progn
	  (setq Format1 "" Format2 "" Format3 "")
	  (foreach item '("L" "O" "~")
	    (if (vl-string-search item Formats)
	      (setq Format1 (strcat Format1 "`" item))
	      (setq All nil)
	    )
	  )
	  (if (= Format1 "")
	    (setq Format1 nil)
	    (setq Format1 (strcat "\\[" Format1 "]"))
	  )
	  (foreach item '("A" "C" "F" "H" "Q" "T" "W")
	    (if (vl-string-search item Formats)
	      (setq Format2 (strcat Format2 item))
	      (setq All nil)
	    )
	  )
	  (if (= Format2 "")
	    (setq Format2 nil)
	    (setq Format2 (strcat "\\[" Format2 "]"))
	  )
	  (if (vl-string-search "P" Formats)
	    (setq Format3 "\\P")
	    (setq Format3 nil All nil)
	  )
	  T
	)
      )
      (while (/= Mtext "")
	(cond
	  ((wcmatch (strcase (setq Str (substr Mtext 1 2))) "\\[\\{}]")
	    (setq Mtext (substr Mtext 3)
		  Text   (strcat Text Str)
	    )
	  )
	  ((and All (wcmatch (substr Mtext 1 1) "[{}]"))
	    (setq Mtext (substr Mtext 2))
	  )
	  ((and Format1 (wcmatch (strcase (substr Mtext 1 2)) Format1))
	    (setq Mtext (substr Mtext 3))
	  )
	  ((and Format2 (wcmatch (strcase (substr Mtext 1 2)) Format2))
	    (setq Mtext (substr Mtext (+ 2 (if (vl-string-search ";" Mtext)(vl-string-search ";" Mtext) 0))))
	  )
	  ((and Format3 (wcmatch (strcase (substr Mtext 1 2)) Format3))
	    (if
	      (or
		(= " " (substr Text (if (zerop (strlen Text)) 1 (strlen Text))))
		(= " " (substr Mtext 3 1))
	      )
	      (setq Mtext (substr Mtext 3))
	      (setq Mtext (substr Mtext 3) Text (strcat Text " "))
	    )
	  )     
	  ((and (vl-string-search "S" Formats)(wcmatch (strcase (substr Mtext 1 2)) "\\S"))
	    (setq Str   (substr Mtext 3 (- (vl-string-search ";" Mtext) 2))
		  Text  (strcat Text (vl-string-translate "#^\\" "/^\\" Str))
		  Mtext (substr Mtext (+ 4 (strlen Str)))
	    )
	  )
	  (1
	    (setq Text (strcat Text (substr Mtext 1 1))
		  Mtext (substr Mtext 2)
	    )
	  )
	)
      )
    )
    (while (setq Pos (vl-string-search "\\U+" Text))
      (setq Str (substr Text (1+ pos) 7)
	    Text (vl-string-subst (chr (hexdec (substr Str 4))) Str Text))
    )
    (vl-string-trim " " Text)
  )

;-------------------------------------------------------------------------
; Slectionner une cellule Excel
;-------------------------------------------------------------------------

  (defun selection_cellule(def msg ok / rep)
    (while (vl-string-search "\"" msg)
      (setq msg (vl-string-subst "" "\"" msg))
    )
    (if (eq (setq rep (inputbox "LXL" (strcat "Veuillez indiquer la rfrence de la cellule\nExemple : A10" msg) def)) "")
      nil
      (progn
	(if (and (or (and (> (vl-string-elt rep 0) 64)(< (vl-string-elt rep 0) 91))
		     (and (> (vl-string-elt rep 0) 96)(< (vl-string-elt rep 0) 123)))
	    (and	  (> (vl-string-elt rep (1- (strlen rep))) 47)(< (vl-string-elt rep (1- (strlen rep))) 58)))
	  rep
	  (progn
	    (if ok
	      (princ (strcat "\nLa valeur \"" rep "\" est incorrecte.\nElle ne correspond pas  une rfrence de cellule Excel."))
	      (msgbox "LXL" 48 (strcat "\nLa valeur \"" rep "\" est incorrecte.\nElle ne correspond pas  une rfrence de cellule Excel."))
	    )
	    nil
	  )
	)
      )
    )
  )

;-------------------------------------------------------------------------
; Incrmenter un texte de +1
;-------------------------------------------------------------------------

;; INCSUFF - Gilles Chanteau - 15/01/08
;; Incrmente le suffixe d'une chane de caractres de la valeur spcifie.
;; Est pris en compte comme suffixe, l'ensemble des caractres [0-9] depuis
;; la fin de la chane ainsi que les caractres [A-Z] et [a-z] si alpha est non nil
;;
;; Arguments
;; str : une chane avec un suffixe valide
;; inc : un entier positif
;; alpha : si non nil, les caractres [a-z] [A-Z] sont intgrs au suffixe
;;
;; Retour
;; la chane avec son suffixe incrment (ou nil si aucun suffixe valide)
;;
;; Exemples :
;; (incsuff "N002" 12 T) = "N014"
;; (incsuff "test_ZZ9" 1 T) = "test_AAA0"
;; (incsuff "test_ZZ9" 1 nil) = "test_ZZ10"
;; (incsuff "12-" 1 nil) = nil

  (defun incsuff (str inc alpha / lst crt pas ind dep quo ret)
    (setq lst (reverse (vl-string->list str)))
    (while
      (and
	(setq crt (car lst))
	(cond
	  ((< 47 crt 58)
	    (setq pas 10
		  ind 48
	    )
	  )
	  ((and alpha (< 64 crt 91))
	    (setq pas 26
		  ind 65
	    )
	  )
	  ((and alpha (< 96 crt 123))
	    (setq pas 26
		  ind 97
	    )
	  )
	  ((< 0 quo)
	    (setq crt (if (= 10 pas)
			ind
			(1- ind)
		      )
		  lst (cons (car lst) lst)
	    )
	  )
	)
      )
      (setq dep (- crt ind)
	    quo (/ (+ dep inc) pas)
	    ret (cons (+ ind (rem (+ dep inc) pas)) ret)
      )
      (if (zerop quo)
	(setq ret (append (reverse (cdr lst)) ret)
	      lst nil
	)
	(if (cdr lst)
	  (setq lst (cdr lst)
		inc quo
	  )
	  (setq lst (list ind)
		inc (if (= 10 pas)
		      quo
		      (1- quo)
		    )
	  )
	)
      )
    )
    (if ret
      (vl-list->string ret)
    )
  )

;-------------------------------------------------------------------------
; Incrmentation automatique des cellules
;-------------------------------------------------------------------------

  (defun incrementation_auto(lst sel / deb fin rep saut)
    (if (setq rep (selection_cellule "" "" T))
      (progn
	(if (or (and (> (vl-string-elt rep 1) 64) (< (vl-string-elt rep 1) 91))
		(and (> (vl-string-elt rep 1) 96) (< (vl-string-elt rep 1) 123)))
	  (setq deb (substr rep 1 2) fin (atoi (substr rep 3)))
	  (setq deb (substr rep 1 1) fin (atoi (substr rep 2)))
	)
	(setq lst (append lst (mapcar '(lambda (x) (if (not saut)
						     (setq saut T)
						     (if (eq position_saisie_excel 2)
						       (setq fin (1+ fin))
						       (setq deb (incsuff deb 1 T))
						     )
						   )
						   (cons x (strcat deb (itoa fin))))
				      (vl-remove-if '(lambda(x) (car (rechercher_data x))) sel))))
      )
    )
  )

;-------------------------------------------------------------------------
; Recherche la liste des fichiers dans la base
;-------------------------------------------------------------------------

  (defun liste_fichiers(/ fic lst tbl)
    (mapcar '(lambda (x) (vl-filename-base (cadr x))) (reverse (vlax-ldata-list cle)))
  )

;-------------------------------------------------------------------------
; Recherche la liste des feuilles dans la base
;-------------------------------------------------------------------------

  (defun liste_feuilles(/ lst sel)
    (mapcar 'car (cdr (vlax-ldata-get cle position_fichier_excel)))
  )

;-------------------------------------------------------------------------
; Afficher la liste des attributs
;-------------------------------------------------------------------------

  (defun affiche_attributs(lst / cha txt)
    (start_list "valeur")
      (mapcar 'add_list (mapcar '(lambda (x)(if (car x)
					      (if (eq (type (car x)) 'ENAME)
						(cdr (assoc 1 (entget (car x))))
						(if (vlax-read-enabled-p (car x))
						  (if (verifier_att (car x))
						    "Lecture impossible"
						    (cond
						      ((eq (vla-get-objectname (car x)) "AcDbMText")
							(setq cha (unformat (vla-get-textstring (car x)) "*"))
							(while (vl-string-search "\\\\" cha)
							  (setq cha (vl-string-subst "\\" "\\\\" cha))
							)
							cha
						      )
						      ((eq (vla-get-objectname (car x)) "AcDbTable")
							(if (eq (setq txt (unformat (vlax-invoke (car x) 'gettext 0 0) "*")) "")
							  "Tableau sans titre"
							  txt
							)
						      )
						      (T
							(vla-get-textstring (car x))
						      )
						    )
						  )
					          "Lecture impossible"
						)
					      )
					      "Lecture impossible"
					    )
				)
				lst)
      )
    (end_list)
  )

;-------------------------------------------------------------------------
; Dfinit s'il y a des attributs de lis avec Excel
;-------------------------------------------------------------------------

  (defun data_ok(/ n ok sel tbl)
    (foreach tbl (vlax-ldata-list cle)
      (setq n 2)
      (while (and (not ok) (setq sel (nth n tbl)))
	(if (cdr sel)
	  (setq ok T n (length tbl))
	)
	(setq n (1+ n))
      )
    )
    ok 
  )

;-------------------------------------------------------------------------
; Recherche un attribut dans la base
;-------------------------------------------------------------------------

  (defun rechercher_data(att / cle_fichier cle_feuille i j n lst sel tbl)
    (setq i 0)
    (while (and (not cle_fichier) (setq lst (vlax-ldata-get cle (itoa i))))
      (setq n 1)
      (while (and (not cle_fichier) (setq sel (nth n lst)))
	(if (assoc att (cdr sel))
	  (setq cle_fichier (car lst) cle_feuille sel n (length lst))
	)
	(setq n (1+ n))
      )
      (setq i (1+ i))
    )
    (list cle_fichier cle_feuille)
  )

;-------------------------------------------------------------------------
; Recherche une valeur dans une chaine
;-------------------------------------------------------------------------

  (defun recherche_valeur(val chaine / cac ok)
    (while (not (eq chaine ""))
      (setq cac (read chaine))
      (if (eq val cac)
	(setq ok T)
      )
      (setq chaine (substr chaine (+ 2 (strlen (itoa cac))) (strlen chaine)))
    )
    ok
  )

;-------------------------------------------------------------------------
; Affiche le Rpertoire o se situe le fichier Excel
;-------------------------------------------------------------------------

  (defun affiche_fichier(/ sel txt)
    (set_tile "fichier" position_fichier_excel)
    (setq txt (vl-filename-directory (car (vlax-ldata-get cle position_fichier_excel))))
    (if (> (strlen txt) 51)
      (setq txt (strcat (substr txt 1 3) "...." (substr txt (- (strlen txt) 50))))
    )
    (set_tile "chemin" txt)
  )

;-------------------------------------------------------------------------
; Vrification que l'attribut est toujours OK
;-------------------------------------------------------------------------

  (defun verifier_att(att)
    (vl-catch-all-error-p (vl-catch-all-apply 'vla-objectidtoobject (list (vla-get-database att)(vla-get-ownerid att))))
  )

;-------------------------------------------------------------------------
; Affiche les infos relatif  l'attribut
;-------------------------------------------------------------------------

  (defun affiche_attribut(/ att lst txt)
    (setq lst (cdr (nth (1+ (atoi position_feuille_excel)) (vlax-ldata-get cle position_fichier_excel)))
	  att (nth (atoi position_att_excel) lst))
    (if (car att)
      (if (vlax-read-enabled-p (car att))
	(if (eq (type (car att)) 'ENAME)
	  (progn
	    (if (eq (substr (cdr att) 1 1) "2")
	      (setq txt ", incrment Ligne")
	      (setq txt ", incrment Colonne")
	    )
	    (set_tile "cellule" (strcat (substr (cdr att) 2) txt))
	    (set_tile "bloc" "Rtext")
	    (set_tile "etiquette" "")
	    (if (> (atoi (substr (getvar "ACADVER") 1 2)) 16)
	      (set_tile "id" (strcase (dechex (vla-get-objectid (vlax-ename->vla-object (car att)))) T))
	      (set_tile "id" "")
	    )
	  )
	  (progn
	    (set_tile "cellule" (cdr att))
	    (if (verifier_att (car att))
	      (progn
		(foreach att (list "bloc" "etiquette" "id")
		  (set_tile att "Lecture impossible")
		)
		(mode_tile "matt" 1)
	      )
	      (progn
		(if (eq (vla-get-objectname (car att)) "AcDbAttribute")
		  (progn
		    (set_tile "bloc" (vla-get-name (vla-objectidtoobject (vla-get-database (car att))(vla-get-ownerid  (car att)))))
		    (set_tile "etiquette" (vla-get-tagstring (car att)))
		  )
		  (progn
		    (if (eq (vla-get-objectname (car att)) "AcDbTable")
		      (set_tile "bloc" "Tableau")
		      (set_tile "bloc" "Texte/Mtext")
		    )
		    (set_tile "etiquette" "")
		  )
		)
		(set_tile "id" (strcase (dechex (vla-get-objectid (car att))) T))
		(mode_tile "matt" 0)
	      )
	    )
	  )
	)
	(progn
	  (if (eq (type (car att)) 'ENAME)
	    (progn
	      (if (eq (substr (cdr att) 1 1) "2")
		(setq txt " et incrment par Ligne")
		(setq txt " et incrment par Colonne")
	      )
	      (set_tile "cellule" (strcat (substr (cdr att) 2) txt))
	    )
	    (set_tile "cellule" (cdr att))
	  )
	  (set_tile "bloc" "Lecture impossible")
	  (set_tile "etiquette" "")
	  (set_tile "id" "")
	  (mode_tile "matt" 1)
	)
      )
      (progn
	(set_tile "cellule" (cdr att))
	(set_tile "bloc" "Lecture impossible")
	(set_tile "etiquette" "")
	(set_tile "id" "")
	(mode_tile "matt" 1)
      )
    )
  )

;-------------------------------------------------------------------------
; Griser ou pas les boutons haut et bas
;-------------------------------------------------------------------------

  (defun haut_bas(/ n lst tbl)
    (setq tbl (cdr (nth (1+ (atoi position_feuille_excel)) (vlax-ldata-get cle position_fichier_excel)))
	  n 0)
    (while (nth n tbl)
      (if (not lst)
	(setq lst (itoa n))
	(setq lst (strcat lst " " (itoa n)))
      )
      (setq n (1+ n))
    )
    (if (eq (vl-string-search position_att_excel lst) 0)
      (mode_tile "haut" 1)
      (mode_tile "haut" 0)
    )
    (if (eq (vl-string-search position_att_excel lst) (- (strlen lst) (strlen position_att_excel)))
      (mode_tile "bas" 1)
      (mode_tile "bas" 0)
    )
  )

;-------------------------------------------------------------------------
; Gestion de la boite de dialogue principale
;-------------------------------------------------------------------------

  (defun gestion_affichage_boite(chg / lst sel)
    (if (not (vlax-ldata-list cle))
      (foreach sel (list "fichier" "sfichier" "cfichier" "chemin" "gfeuille" "att" "maja" "maje")
	(mode_tile sel 1)
      )
      (progn
	(start_list "fichier")
	  (mapcar 'add_list (liste_fichiers))
	(end_list)
	(or position_fichier_excel
	  (setq position_fichier_excel "0")
	)
	(or position_feuille_excel
	  (setq position_feuille_excel "0")
	)
	(or position_saisie_excel
	  (setq position_saisie_excel 1)
	)
	(or position_maj_autocad
	  (setq position_maj_autocad 1)
	)
	(or position_maj_excel
	  (setq position_maj_excel 1)
	)
	(affiche_fichier)
	(if (not (data_ok))
	  (progn
	    (mode_tile "maj1" 1)
	    (mode_tile "maj2" 1)
	    (mode_tile "maj3" 1)
	    (mode_tile "maj4" 1)
	  )
	)
	(affiche_fichier)
	(if (cadr (vlax-ldata-get cle position_fichier_excel))
	  (progn
	    (cond
	      ((eq position_saisie_excel 1)
		(mode_tile "libre" 2)
	      )
	      ((eq position_saisie_excel 2)
		(mode_tile "ligne" 2)
	      )
	      ((eq position_saisie_excel 3)
		(mode_tile "colonne" 2)
	      )
	    )
	    (cond
	      ((eq position_maj_autocad 1)
		(mode_tile "toutae" 2)
	      )
	      ((eq position_maj_autocad 2)
		(mode_tile "attae" 2)
	      )
	      ((eq position_maj_autocad 3)
		(mode_tile "tabae" 2)
	      )
	    )
	    (cond
	      ((eq position_maj_excel 1)
		(mode_tile "toutea" 2)
	      )
	      ((eq position_maj_excel 2)
		(mode_tile "attea" 2)
	      )
	      ((eq position_maj_excel 3)
		(mode_tile "tabea" 2)
	      )
	    )
	    (mode_tile "accept" 2)
	    (foreach sel (list "feuille" "sfeuille" "cfeuille" "att")
	      (mode_tile sel 0)
	    )
	    (if (setq lst (cdr (nth (1+ (atoi position_feuille_excel)) (vlax-ldata-get cle position_fichier_excel))))
	      (progn
		(foreach sel (list "id" "aatt1" "aatt2" "satt" "matt" "change" "haut" "bas" "cellule" "bloc" "etiquette" "valeur")
		  (mode_tile sel 0)
		)
		(affiche_attributs lst)
		(if (not position_att_excel)
		  (setq position_att_excel "0")
		)
		(set_tile "valeur" "")
		(set_tile "valeur" position_att_excel)
		(affiche_attribut)
		(haut_bas)
	      )
	      (foreach sel (list "id" "satt" "matt" "change" "haut" "bas" "cellule" "bloc" "etiquette" "valeur")
		(mode_tile sel 1)
	      )
	    )
	    (start_list "feuille")
	      (mapcar 'add_list (liste_feuilles))
	    (end_list)
	    (if chg
	      (setq position_feuille_excel "0")
	    )
	  )
	  (progn
	    (foreach sel (list "feuille" "sfeuille" "cfeuille" "att" )
	      (mode_tile sel 1)
	    )
	    (setq position_feuille_excel "0")
	  )
	)
	(set_tile "feuille" position_feuille_excel)
      )
    )
  )

;-------------------------------------------------------------------------
; Mise  jour de l'affichage en fonction de la slection du fichier
;-------------------------------------------------------------------------

  (defun position_fichier(val)
    (setq position_fichier_excel val position_feuille_excel "0" position_att_excel "0")
    (gestion_affichage_boite T)
  )

;-------------------------------------------------------------------------
; Mise  jour de l'affichage en fonction de la slection de la feuille
;-------------------------------------------------------------------------

  (defun position_feuille(val)
    (setq position_feuille_excel val position_att_excel "0")
    (gestion_affichage_boite nil)
    (if (eq position_saisie_excel 1)
      (affiche_trier nil)
      (affiche_trier T)
    )
  )

;-------------------------------------------------------------------------
; Mise  jour de l'affichage en fonction de la slection de l'attribut
;-------------------------------------------------------------------------

  (defun position_attribut(val)
    (setq position_att_excel val)
    (affiche_attribut)
    (haut_bas)
  )

;-------------------------------------------------------------------------
; Ajouter un fichier
;-------------------------------------------------------------------------

  (defun ajouter_fichier(/ fic ok sel)
    (if (not chemin_fichier_excel)
      (setq chemin_fichier_excel (getvar "dwgprefix"))
    )
    (if (setq fic (getfiled "Veuillez slectionner un fichier Excel" chemin_fichier_excel "xls" 16))
      (progn
	(setq chemin_fichier_excel (strcat (vl-filename-directory fic) "\\"))
	(foreach sel (vlax-ldata-list cle)
	  (if (eq (strcase fic) (strcase (cadr sel)))
	    (setq ok T position_fichier_excel (car sel))
	  )
	)
	(if ok
	  (progn
	    (affiche_fichier)
	    (msgbox "LXL" 48 (strcat "Le fichier \"" (vl-filename-base fic) ".xls\" est dj rfrenc dans le dessin."))
	  )
	  (progn
	    (setq position_fichier_excel (itoa (length (vlax-ldata-list cle))))
	    (vlax-ldata-put cle position_fichier_excel (list fic))
	    (if (eq position_fichier_excel "0")
	      (progn
		(foreach sel (list "fichier" "sfichier" "cfichier" "chemin" "gfeuille")
		  (mode_tile sel 0)
		)
		(foreach sel (list "feuille" "sfeuille" "cfeuille")
		  (mode_tile sel 1)
		)
	      )
	    )
	    (start_list "fichier" 2)
	      (add_list (vl-filename-base fic))
	    (end_list)
	    (set_tile "fichier" position_fichier_excel)
	  )
	)
	(gestion_affichage_boite nil)
      )
    )
  )

;-------------------------------------------------------------------------
; Supprimer un fichier
;-------------------------------------------------------------------------

  (defun supprimer_fichier(/ i n ok tbl)
    (setq tbl (vlax-ldata-get cle position_fichier_excel) i 0 n 0)
    (if (cdr tbl)
      (if (eq (msgbox "LXL" (+ 48 1 256) (strcat "Des feuilles Excel sont lis avec le fichier\n\"" (car tbl) "\"\nDsirez-vous le supprimer ?")) 2)
	(setq ok T)
      )
    )
    (if (not ok)
      (progn
	(while (setq tbl (vlax-ldata-get cle (itoa n)))
	  (if (not (eq (itoa n) position_fichier_excel))
	    (progn
	      (vlax-ldata-put cle (itoa i) tbl)
	      (setq i (1+ i))
	    )
	  )
	  (setq n (1+ n))
	)
	(vlax-ldata-delete cle (itoa (1- n)))
	(if (> (atoi position_fichier_excel) 0)
	  (setq position_fichier_excel (itoa (1- (atoi position_fichier_excel))))
	)
	(gestion_affichage_boite nil)
      )
    )
    (or (vlax-ldata-list cle)
      (setq position_fichier_excel nil)
    )
  )

;-------------------------------------------------------------------------
; Changer un fichier
;-------------------------------------------------------------------------

  (defun changer_fichier(/ fic ok sel)
    (if (not chemin_fichier_excel)
      (setq chemin_fichier_excel (getvar "dwgprefix"))
    )
    (if (setq fic (getfiled "Veuillez slectionner un fichier Excel" chemin_fichier_excel "xls" 16))
      (progn
	(setq chemin_fichier_excel (strcat (vl-filename-directory fic) "\\"))
	(foreach sel (vlax-ldata-list cle)
	  (if (eq (strcase fic) (strcase (cadr sel)))
	    (setq ok T position_fichier_excel (car sel))
	  )
	)
	(if ok
	  (progn
	    (affiche_fichier)
	    (msgbox "LXL" 48 (strcat "Le fichier \"" (vl-filename-base fic) ".xls\" est dj rfrenc dans le dessin."))
	  )
	  (progn
	    (setq sel (cons fic (cdr (vlax-ldata-get cle position_fichier_excel))))
	    (vlax-ldata-put cle position_fichier_excel sel)
	    (gestion_affichage_boite nil)
	  )
	)
      )
    )
  )

;-------------------------------------------------------------------------
; Message d'erreur de fichier non trouv
;-------------------------------------------------------------------------

  (defun erreur_fichier()
    (msgbox "LXL" 16 (strcat "Le fichier \""
			     (vl-filename-base (car (vlax-ldata-get cle position_fichier_excel)))
			     (vl-filename-extension (car (vlax-ldata-get cle position_fichier_excel)))
			     "\" est introuvable.\nSoit il a t renomm, supprim ou dplac du rpertoire\n\""
			     (vl-filename-directory (car (vlax-ldata-get cle position_fichier_excel)))
			     "\"."
		     )
    )
  )

;-------------------------------------------------------------------------
; Verifie si la feuille est actif dans Excel, si non l'ouvre
;-------------------------------------------------------------------------

  (defun verifier_excel()
    (if (not xl)
      (lancer_excel)
    )
    (if xls
      (if (not (eq (strcase (vlax-get xls 'fullname)) (strcase (car (vlax-ldata-get cle position_fichier_excel)))))
	(progn
	  (if (not (member (strcase (vlax-get xls 'fullname)) liste_fichiers_ouvert))
	    (vlax-invoke-method xls 'close :vlax-false)
	  )
	  (vlax-release-object xls)
	  (setq xls nil)
	)
      )
    )
    (vlax-for sel wks
      (if (eq (strcase (vlax-get sel 'fullname)) (strcase (car (vlax-ldata-get cle position_fichier_excel))))
	(setq xls sel)
      )
    )
    (if (not xls)
      (setq xls (vlax-invoke wks 'open (car (vlax-ldata-get cle position_fichier_excel))))
    )
    (setq classeur (vlax-get xls 'sheets))
  )

;-------------------------------------------------------------------------
; Ajouter une feuille Excel
;-------------------------------------------------------------------------

  (defun ajouter_feuille(/ feu n lance lst ok sel)
    (if (findfile (car (vlax-ldata-get cle position_fichier_excel)))
      (progn
	(verifier_excel)
	(if (setq feu (choix_feuille classeur))
	  (progn
	    (setq lst (vlax-ldata-get cle position_fichier_excel) n 0)
	    (if (cdr lst)
	      (while (setq sel (nth n (cdr lst)))
		(if (eq (strcase (car sel)) (strcase feu))
		  (setq ok T position_feuille_excel (itoa n) n (length (cdr lst)))
		)
		(setq n (1+ n))
	      )
	    )
	    (if ok
	      (msgbox "LXL" 48 (strcat "La feuille \"" feu "\" est dj rfrence dans le dessin."))
	      (progn
		(setq lst (append lst (list (list feu))))
		(vlax-ldata-put cle position_fichier_excel lst)
		(start_list "feuille" 2)
		  (add_list feu)
		(end_list)
		(foreach rec (list "feuille" "sfeuille" "cfeuille")
		  (mode_tile rec 0)
		)
		(mode_tile "att" 1)
		(setq position_feuille_excel (itoa (1- (length (cdr lst)))))
	      )
	    )
	    (gestion_affichage_boite nil)
	  )
	)
      )
      (erreur_fichier)
    )
  )

;-------------------------------------------------------------------------
; Supprimer une feuille Excel
;-------------------------------------------------------------------------

  (defun supprimer_feuille(/ lst ok tbl)
    (setq tbl (nth (1+ (atoi position_feuille_excel)) (vlax-ldata-get cle position_fichier_excel)))
    (if (cdr tbl)
      (if (eq (msgbox "LXL" (+ 48 1 256) (strcat "Des attributs sont lis avec la feuille \"" (car tbl) "\"\nDsirez-vous la supprimer ?")) 2)
	(setq ok T)
      )
    )
    (if (not ok)
      (progn
	(setq lst (vl-remove tbl (vlax-ldata-get cle position_fichier_excel)))
	(vlax-ldata-put cle position_fichier_excel lst)
	(if (> (atoi position_feuille_excel) 0)
	  (setq position_feuille_excel (itoa (1- (atoi position_feuille_excel))))
	)
	(setq position_att_excel "0")
	(gestion_affichage_boite nil)
      )
    )
  )

;-------------------------------------------------------------------------
; Changer de feuille Excel
;-------------------------------------------------------------------------

  (defun changer_feuille(/ feu lst n ok sel tbl)
    (if (findfile (car (vlax-ldata-get cle position_fichier_excel)))
      (progn
	(verifier_excel)
	(if (setq feu (choix_feuille classeur))
	  (progn
	    (setq lst (vlax-ldata-get cle position_fichier_excel) n 0)
	    (if (cdr lst)
	      (while (setq sel (nth n (cdr lst)))
		(if (eq (strcase (car sel)) (strcase feu))
		  (setq ok T position_feuille_excel (itoa n) n (length (cdr lst)))
		)
		(setq n (1+ n))
	      )
	    )
	    (if ok
	      (msgbox "LXL" 48 (strcat "La feuille \"" feu "\" est dj rfrence dans le dessin."))
	      (progn
		(setq tbl (nth (1+ (atoi position_feuille_excel)) (vlax-ldata-get cle position_fichier_excel))
		      lst (subst (cons feu (cdr tbl)) tbl (vlax-ldata-get cle position_fichier_excel)))
		(vlax-ldata-put cle position_fichier_excel lst)
		(gestion_affichage_boite nil)
	      )
	    )
	  )
	)
      )
      (erreur_fichier)
    )
  )

;-------------------------------------------------------------------------
; Ajouter une liaison avec attribut
;-------------------------------------------------------------------------

  (defun ajouter_attributs(ok / att blo col deb degriser err n lst old r rep sel txt)

    (defun degriser(/ att)
      (if sel
	(progn
	  (foreach att sel
	    (if (eq (type att) 'ENAME)
	      (redraw att 4)
	      (redraw (vlax-vla-object->ename att) 4)
	    )
	  )
	)
      )
    )

    (defun err (msg)
      (if (/= msg "Fonction annule") 
	(princ (strcat "\nErreur : " msg))
	(princ msg)
      )
      (setq *error* old)
      (if xl
	(fermer_excel)
      )
      (degriser)
      (unload_dialog lxl_dia)
      (vla-endundomark (vla-get-activedocument (vlax-get-acad-object)))
      (princ)
    )

    (setq lst (nth (1+ (atoi position_feuille_excel)) (vlax-ldata-get cle position_fichier_excel)) old *error* *error* err)
    (if ok
      (progn
	(while (setq att (nentsel "\nVeuillez slectionner un Attribut/Texte/Mtext : "))
	  (if (member (cdr (assoc 0 (entget (car att)))) (list "ATTRIB" "TEXT" "MTEXT"))
	    (if (or (and (eq (type (car (last att))) 'ENAME)
			 (eq (cdr (assoc 0 (entget (car (last att))))) "ACAD_TABLE")
		    )
		    (not (eq (type (car (last att))) 'ENAME))
		)
	      (if (not (vl-catch-all-error-p (vl-catch-all-apply 'vla-get-document (list (vlax-ename->vla-object (car att))))))
		(progn
		  (setq att (vlax-ename->vla-object (car att)) r nil)
		  (if (car (setq r (rechercher_data att)))
		    (princ (strcat "\nAttribut/Texte/Mtext dj associ avec la feuille \""
				   (caar (cdr r))
				   "\" du fichier \""
				   (car r)
				   "\"."
			   )
		    )
		    (if (eq position_saisie_excel 1)
		      (if (assoc att (cdr lst))
			(princ "\nAttribut/Texte/Mtext dj slectionn.")
			(progn
			  (if (eq (type att) 'ENAME)
			    (redraw att 3)
			    (redraw (vlax-vla-object->ename att) 3)
			  )
			  (if (setq rep (selection_cellule "" "" T))
			    (setq lst (append lst (list (cons att rep)))
				  sel (append sel (list att)))
			    (if (eq (type att) 'ENAME)
			      (redraw att 4)
			      (redraw (vlax-vla-object->ename att) 4)
			    )
			  )
			)
		      )
		      (if (not (member att sel))
			(progn
			  (if (eq (type att) 'ENAME)
			    (redraw att 3)
			    (redraw (vlax-vla-object->ename att) 3)
			  )
			  (setq sel (append sel (list att)))
			)
			(princ "\nAttribut/Texte/Mtext dj slectionn.")
		      )
		    )
		  )
		)
		(princ "\nCet lment appartient  un objet indtermin.")
	      )
	      (princ (strcat "\nCet lment appartient  un "
			     (if (eq (vla-get-isxref
				       (vla-item (vla-get-blocks (vla-get-activedocument (vlax-get-acad-object)))
						 (cdr (assoc 2 (entget (car (last att)))))
				       )
				     )
				     :vlax-true
				 )
				 "xref"
				 "bloc"
			     )
			     "."
		      )
	      )
	    )
	    (princ "\nCe n'est pas un Attribut/Texte/Mtext.")
	  )
	)
	(degriser)
	(if (and sel (not (eq position_saisie_excel 1)))
	  (setq lst (incrementation_auto lst sel))
	)
      )
      (progn
	(if (setq blo (entsel "\nVeuillez slectionner un Bloc/Rtext/Table : "))
	  (cond
	    ((eq (cdr (assoc 0 (entget (car blo)))) "INSERT")
	      (if (setq sel (vlax-invoke (vlax-ename->vla-object (car blo)) 'getattributes))
		(if (eq position_saisie_excel 1)
		  (progn
		    (foreach att sel
		      (if (not (car (rechercher_data att)))
			(progn
			  (setq txt (strcat "\nBloc : " (vla-get-name (vla-objectidtoobject (vla-get-database att)(vla-get-ownerid att)))
					    "\nEtiquette : " (vla-get-tagstring att)
					    "\nValeur Attribut : " (vla-get-textstring att)
					    "\nID : " (strcase (dechex (vla-get-objectid att)) T)))
			  (if (setq rep (selection_cellule "" txt T))
			    (setq lst (append lst (list (cons att rep))))
			    (setq lst (append lst (list (cons att "A1"))))
			  )
			)
		      )
		    )
		    (if (not txt)
		      (msgbox "LXL" 48 "Le bloc slectionn est dj compltement intgr dans la base.")
		    )
		  )
		  (if (vl-remove-if '(lambda(x) (car (rechercher_data x))) sel)
		    (setq lst (incrementation_auto lst sel))
		    (msgbox "LXL" 48 "Le bloc slectionn est dj compltement intgr dans la base.")
		  )
		)
		(msgbox "LXL" 48 "Le bloc slectionn ne possde pas d'attributs.")
	      )
	    )
	    ((eq (cdr (assoc 0 (entget (car blo)))) "RTEXT")
	      (if (not (car (rechercher_data (car blo))))
		(if (eq position_saisie_excel 1)
		  (msgbox "LXL" 48  "\nPas de saisie libre des cellules pour un Rtext.")
		  (if (setq rep (selection_cellule "" "" T))
		    (setq lst (append lst (list (cons (car blo) (strcat (itoa position_saisie_excel) rep)))))
		  )
		)
		(msgbox "LXL" 48 "Le RTEXT slectionn est dj intgr dans la base.")
	      )
	    )
	    ((eq (cdr (assoc 0 (entget (car blo)))) "ACAD_TABLE")
	      (setq sel (vlax-ename->vla-object (car blo)))
	      (if (not (car (rechercher_data sel)))
		(if (setq rep (selection_cellule "" "" T))
		  (setq lst (append lst (list (cons sel rep))))
		  (setq lst (append lst (list (cons sel "A1"))))
		)
	      )
	    )
	    (T
	      (msgbox "LXL" 48  "\nCe n'est pas un Bloc, un Rtext ou un Tableau.")
	    )
	  )
	)
      )
    )
    (if lst
      (progn
	(setq sel (list (car (vlax-ldata-get cle position_fichier_excel))) n 1)
	(while (setq att (nth n (vlax-ldata-get cle position_fichier_excel)))
	  (if (eq (atoi position_feuille_excel) (1- n)) 
	    (setq sel (append sel (list lst)))
	    (setq sel (append sel (list att)))
	  )
	  (setq n (1+ n))
	)
	(vlax-ldata-put cle position_fichier_excel sel)
      )
    )
    (setq *error* old)
  )

;-------------------------------------------------------------------------
; Supprimer une liaison avec un attribut
;-------------------------------------------------------------------------

  (defun supprimer_attribut(/ lec lst n sel tbl)
    (setq tbl (nth (1+ (atoi position_feuille_excel)) (vlax-ldata-get cle position_fichier_excel)) n 0)
    (while (setq lec (nth n (cdr tbl)))
      (if (not (recherche_valeur n position_att_excel))
	(setq lst (append lst (list lec)))
      )
      (setq n (1+ n))
    )
    (setq lst (cons (car tbl) lst)
	  sel (subst lst tbl (vlax-ldata-get cle position_fichier_excel)))
    (vlax-ldata-put cle position_fichier_excel sel)
    (if (> (length lst) 1)
      (progn
	(affiche_attributs (cdr lst))
	(setq position_att_excel (itoa (read position_att_excel)))
	(if (> (atoi position_att_excel) 0)
	  (setq position_att_excel (itoa (1- (atoi position_att_excel))))
	  (setq position_att_excel "0")
	)
	(set_tile "valeur" "")
	(set_tile "valeur" position_att_excel)
	(affiche_attribut)
	(if (= (length (cdr lst)) 1)
	  (foreach sel (list "haut" "bas" "trier")
	    (mode_tile sel 1)
	  )
	)
      )
      (progn
	(foreach sel (list "id" "satt" "matt" "change" "haut" "bas" "cellule" "bloc" "etiquette" "valeur")
	  (mode_tile sel 1)
	)
	(if (not (data_ok))
	  (progn
	    (mode_tile "maj1" 1)
	    (mode_tile "maj2" 1)
	    (mode_tile "maj3" 1)
	    (mode_tile "maj4" 1)
	  )
	)
      )
    )
  )

;-------------------------------------------------------------------------
; Rechercher si l'attribut est li avec LATT
;-------------------------------------------------------------------------

  (defun rechercher_data_lxl(data / n r)
    (foreach n (vlax-ldata-list "Patrick_35")
      (if (member data (cdr n))
	(setq r n)
      )
    )
    r
  )

;-------------------------------------------------------------------------
; Changer le texte
;-------------------------------------------------------------------------

  (defun Changer_attributs(att txt / err j n val1 val2 ecrire_texte_somme)
    (defun ecrire_texte_somme(val1 val2 obj / sv_zp)
      (setq sv_zp (getvar "dimzin"))
      (setvar "dimzin" 4)
      (if (and (not (eq (type val1) 'INT))(not (eq (type val1) 'REAL)))
	(setq val1 0)
      )
      (if (and (not (eq (type val2) 'INT))(not (eq (type val2) 'REAL)))
	(setq val2 0)
      )
      (if (or (eq (type val1) 'REAL) (eq (type val2) 'REAL))
	(setq err (vl-catch-all-apply 'vla-put-textstring (list obj (rtos (+ val1 val2)))))
	(setq err (vl-catch-all-apply 'vla-put-textstring (list obj (itoa (+ val1 val2)))))
      )
      (setvar "dimzin" sv_zp)
    )

    (setq att (append (list (car att) (cadr att) txt) (member (cadddr att) att)) n 3)
    (vlax-ldata-put "Patrick_35" (car att) (cdr att))
    (while (setq j (nth n att))
      (if (vlax-read-enabled-p j)
	(cond
	  ((eq (cadr att) "Identique")
	    (setq err (vl-catch-all-apply 'vla-put-textstring (list j (caddr att))))
	  )
	  ((eq (cadr att) "Croissant")
	    (if (eq n 3)
	      (setq err (vl-catch-all-apply 'vla-put-textstring (list j (caddr att))))
	      (setq err (vl-catch-all-apply 'vla-put-textstring (list j (incsuff (vla-get-textstring (nth (1- n) att)) 1 T))))
	    )
	  )
	  ((eq (cadr att) "Somme")
	    (if (eq n 3)
	      (setq val1 0 val2 0)
	      (setq val1 (read (vla-get-textstring (cadddr att))) val2 (read (vla-get-textstring j)))
	    )
	    (ecrire_texte_somme val1 val2 (cadddr att))
	  )
	)
      )
      (setq n (1+ n))
    )
    (if (vl-catch-all-error-p err)
      T
      nil
    )
  )

;-------------------------------------------------------------------------
; Modifier une liaison avec un attribut
;-------------------------------------------------------------------------

  (defun modifier_attributs(/ changer_valeur deb fin lst rep pos sai saut sel tbl txt1 txt2)

    (defun changer_valeur()
      (setq tbl (subst (cons (car sel)
			     (if (eq (type (car sel)) 'ENAME)
			       (if (> position_saisie_excel 1)
				 (strcat (itoa position_saisie_excel) rep)
				 (strcat (substr (cdr sel) 1 1) rep)
			       )
			       rep
			     )
		       ) sel tbl) saut T)
    )

    (setq tbl (nth (1+ (atoi position_feuille_excel)) (vlax-ldata-get cle position_fichier_excel))
	  lst tbl
	  sai position_att_excel)
    (while (not (eq sai ""))
      (setq pos (read sai) sel (nth (1+ pos) tbl))
      (if (or (eq position_saisie_excel 1) (not saut))
	(progn
	  (cond
	    ((eq (type (car sel)) 'ENAME)
	      (setq txt1 (strcat "\nRtext\nID : " (strcase (dechex (vla-get-objectid (vlax-ename->vla-object (car sel)))) T)) txt2 (substr (cdr sel) 2))
	    )
	    ((eq (vla-get-objectname (car sel)) "AcDbAttribute")
	      (setq txt1 (strcat "\nBloc : " (vla-get-name (vla-objectidtoobject (vla-get-database (car sel))(vla-get-ownerid (car sel))))
					     "\nEtiquette : " (vla-get-tagstring (car sel))
					     "\nValeur Attribut : " (vla-get-textstring (car sel))
					     "\nID : " (strcase (dechex (vla-get-objectid (car sel))) T))
		    txt2 (cdr sel))
	    )
	    ((eq (vla-get-objectname (car sel)) "AcDbTable")
	      (setq txt1 (strcat "\nTableau : " (unformat (vlax-invoke (car sel) 'gettext 0 0) "*") "\nID : " (strcase (dechex (vla-get-objectid (car sel))) T)) txt2 (cdr sel))
	    )
	    (T
	      (setq txt1 (strcat "\nTexte/Mtext\n ID : " (strcase (dechex (vla-get-objectid (car sel))) T)) txt2 (cdr sel))
	    )
	  )
	  (if (setq rep (selection_cellule txt2 txt1 T))
	    (progn
	      (if (or (and (> (vl-string-elt rep 1) 64) (< (vl-string-elt rep 1) 91))
		      (and (> (vl-string-elt rep 1) 96) (< (vl-string-elt rep 1) 123)))
		(setq deb (substr rep 1 2) fin (atoi (substr rep 3)))
		(setq deb (substr rep 1 1) fin (atoi (substr rep 2)))
	      )
	      (changer_valeur)
	    )
	  )
	)
	(progn
	  (if (eq position_saisie_excel 2)
	    (setq fin (1+ fin))
	    (setq deb (incsuff deb 1 T))
	  )
	  (setq rep (strcat deb (itoa fin)))
	  (changer_valeur)
	)
      )
      (setq sai (substr sai (+ 2 (strlen (itoa pos))) (strlen sai)))
    )
    (vlax-ldata-put cle position_fichier_excel (subst tbl lst (vlax-ldata-get cle position_fichier_excel)))
    (affiche_attribut)
  )

;-------------------------------------------------------------------------
; Mettre les attributs selon l'ordre souhait vers le haut
;-------------------------------------------------------------------------

  (defun trier_attributs_haut(/ lec lst n pos sel tab tbl tot)
    (setq tbl (cdr (nth (1+ (atoi position_feuille_excel)) (vlax-ldata-get cle position_fichier_excel)))
	  lst tbl n 0 pos (strcat " "position_att_excel) lec "")
    (while (nth n tbl)
      (if (not tot)
	(setq tot (itoa n))
	(setq tot (strcat tot " " (itoa n)))
      )
      (setq n (1+ n))
    )
    (while (not (eq pos ""))
      (setq sel (read pos))
      (if (not (eq (vl-string-search (strcat lec  " " (itoa sel)) tot) 0))
	(if (> sel 0)
	  (progn
	    (setq tab (nth (1- sel) tbl)
		  tbl (append (reverse (cdr (member tab (reverse tbl))))
			      (list (nth sel tbl))
			      (list tab)
			      (cdr (member (nth sel tbl) tbl))
		      )
	    )
	    (if (eq lec "")
	      (setq lec (itoa (1- sel)))
	      (setq lec (strcat lec " " (itoa (1- sel))))
	    )
	  )
	  (setq lec "0")
	)
	(if (eq lec "")
	  (setq lec (itoa sel))
	  (setq lec (strcat lec " " (itoa sel)))
	)
      )
      (setq pos (substr pos (+ 2 (strlen (itoa sel))) (strlen pos)))
    )

    (setq tbl (cons (car (nth (1+ (atoi position_feuille_excel)) (vlax-ldata-get cle position_fichier_excel))) tbl)
	  lst (cons (car tbl) lst))
    (if (not (eq lec ""))
      (setq position_att_excel lec)
    )
    (vlax-ldata-put cle position_fichier_excel (subst tbl lst (vlax-ldata-get cle position_fichier_excel)))
    (affiche_attributs (cdr tbl))
    (set_tile "valeur" "")
    (set_tile "valeur" position_att_excel)
    (haut_bas)
   )

;-------------------------------------------------------------------------
; Mettre les attributs selon l'ordre souhait vers le bas
;-------------------------------------------------------------------------

  (defun trier_attributs_bas(/ lec lst n pos sel tab tbl tot)
    (setq tbl (cdr (nth (1+ (atoi position_feuille_excel)) (vlax-ldata-get cle position_fichier_excel)))
	  lst tbl n 0 pos position_att_excel lec "")
    (while (nth n tbl)
      (if (not tot)
	(setq tot (itoa n))
	(setq tot (strcat (itoa n) " " tot))
      )
      (setq n (1+ n))
    )
    (while (not (eq pos ""))
      (setq sel (read pos))
      (if (eq lec "")
	(setq lec (itoa sel))
	(setq lec (strcat (itoa sel) " " lec))
      )
      (setq pos (substr pos (+ 2 (strlen (itoa sel))) (strlen pos)))
    )
    (setq pos (strcat " " lec) lec "")
    (while (not (eq pos ""))
      (setq sel (read pos))
      (if (not (eq (vl-string-search (strcat lec " " (itoa sel)) tot) 0))
	(if (< sel (1- (length tbl)))
	  (progn
	    (setq tab (nth (1+ sel) tbl)
		  tbl (append (reverse (cdr (member (nth sel tbl) (reverse tbl))))
			      (list tab)
			      (list (nth sel tbl))
			      (cdr (member tab tbl))
		      )
	    )
	    (if (eq lec "")
	      (setq lec (itoa (1+ sel)))
	      (setq lec (strcat lec " " (itoa (1+ sel))))
	    )
	  )
	  (if (eq lec "")
	    (setq lec (itoa sel))
	    (setq lec (strcat lec " " (itoa sel)))
	  )
	)
	(if (eq lec "")
	  (setq lec (itoa sel))
	  (setq lec (strcat lec " " (itoa sel)))
	)
      )
      (setq pos (substr pos (+ 2 (strlen (itoa sel))) (strlen pos)))
    )
    (setq tbl (cons (car (nth (1+ (atoi position_feuille_excel)) (vlax-ldata-get cle position_fichier_excel))) tbl)
	  lst (cons (car tbl) lst))
    (while (not (eq lec ""))
      (setq sel (read lec))
      (if (eq pos "")
	(setq pos (itoa sel))
	(setq pos (strcat (itoa sel) " " pos))
      )
      (setq lec (substr lec (+ 2 (strlen (itoa sel))) (strlen lec)))
    )
    (if (not (eq pos ""))
      (setq position_att_excel pos)
    )
    (vlax-ldata-put cle position_fichier_excel (subst tbl lst (vlax-ldata-get cle position_fichier_excel)))
    (affiche_attributs (cdr tbl))
    (set_tile "valeur" "")
    (set_tile "valeur" position_att_excel)
    (haut_bas)
  )

;-------------------------------------------------------------------------
; Lancer le traitement de mise  jour
;-------------------------------------------------------------------------

  (defun mise_a_jour(ok / anc cel cha deb der err erreur express feu fin fus inc lst old
			  pas pos rep rxt saut sel strsel tab tai tbl tot tst txt val
			  ecriture_attributs ecriture_rtext ecriture_tableau
			  lecteur_attributs lecture_rtext lecture_tableau)

;-------------------------------------------------------------------------
; Afficher les erreurs
;-------------------------------------------------------------------------

    (defun erreur(msg)
      (if (member ok '(0 1 2 3))
	(progn
	  (start_list "lst" 2)
	  (add_list msg)
	  (end_list)
	)
      )
    )

;-------------------------------------------------------------------------
; Ecriture depuis Excel vers Autocad des tableaux
;-------------------------------------------------------------------------

    (defun ecriture_tableau()
      (or (setq val (vlax-get
		      (vlax-get-property
			(vlax-get-property classeur 'item (car lst))
			'range
			strsel
		      )
		      'value2
		    )
	  )
	(setq val "")
      )
      (if (or (eq (type val) 'REAL) (eq (type val) 'INT))
	(setq val (rtos val))
      )
      (setq old (vl-catch-all-apply 'vla-gettext (list tab pas col)))
      (and (vl-string-search "{" old)
	   (setq anc (unformat old "*"))
	(cond
	  ((vl-string-search (strcat ";" anc) old)
	    (setq val (vl-string-subst (strcat ";" val) (strcat ";" anc) old))
	  )
	  ((vl-string-search (strcat anc "{") old)
	    (setq val (vl-string-subst (strcat val "{") (strcat anc "{") old))
	  )
	  ((vl-string-search (strcat "}" anc) old)
	    (setq val (vl-string-subst (strcat "}" val) (strcat "}" anc) old))
	  )
	)
      )
      (if (and (/= old val) (vl-catch-all-error-p (vl-catch-all-apply 'vla-settext (list tab pas col val))))
	(progn
	  (erreur (strcat "Impossible de modifier la cellule, Colonne "
			  (chr (+ 65 col))
			  ", Ligne "
			  (itoa (1+ pas))
			  ", du Tableau ID = "
			  (strcase (dechex (vla-get-objectid tab)) T)
		  )
	  )
	  (erreur (strcat "Vrifiez par exemple que la cellule, le calque \""
			  (vla-get-layer tab)
			  "\" n'est pas verrouill."
			  )
		  )
	  (erreur "")
	  (setq err T)
	)
	(or (vl-catch-all-error-p old) (member ok '(0 1 4 5))
	  (vl-catch-all-apply 'vla-settext (list tab pas col old))
	)
      )
    )

;-------------------------------------------------------------------------
; Ecriture depuis Excel vers Autocad des attributs/textes
;-------------------------------------------------------------------------

    (defun ecriture_attributs()
      (if (setq cha (cdr (assoc 360 (entget (vlax-vla-object->ename (car sel))))))
	(if (eq (cdr (assoc 3 (entget cha))) "ACAD_FIELD")
	  (progn
	    (erreur (strcat "Pas de mise  jour possible d'un champ affect  la cellule \""
			  (cdr sel)
			    "\", de la feuille \""
			    (car lst)
			    "\","
			   )
		     )
	    (erreur (strcat "du fichier \"" (cadr tbl) "\"."))
	    (erreur "")
	    (setq err T)
	  )
	  (setq cha nil)
	)
      )
      (if (not cha)
	(progn
	  (or (setq val (vlax-get
			  (vlax-get-property
			    (vlax-get-property classeur 'item (car lst))
			    'range
			    (cdr sel)
			  )
			  'value2
			)
	      )
	    (setq val "")
	  )
	  (if (setq rec (rechercher_data_lxl (car sel)))
	    (and (member ok '(0 1 4 5))
	      (setq err (Changer_attributs rec val))
	    )
	    (progn
	      (setq old (vl-catch-all-apply 'vla-get-textstring (list (car sel))))
	      (if (vl-catch-all-error-p (vl-catch-all-apply 'vla-put-textstring (list (car sel) val)))
		(progn
		  (erreur (strcat "Impossible de modifier l'Attribut/Texte/Mtext ID="
				  (strcase (dechex (vla-get-objectid (car sel))) T)
				  (if (eq (vla-get-objectname (car sel)) "AcDbAttribute")
				    (strcat " du bloc \""
					    (vla-get-name
					      (vla-objectidtoobject
					        (vla-get-database (car sel))
						(vla-get-ownerid  (car sel))
					      )
					    )
				    )
				    ""
				  )
				  "\"."
			  )
		  )
		  (erreur (strcat "Vrifiez par exemple que le calque \""
				  (vla-get-layer (car sel))
				  "\" n'est pas verrouill."
			  )
		  )
		  (erreur "")
		  (setq err T)
		)
		(or (vl-catch-all-error-p old) (member ok '(0 1 4 5))
		  (vl-catch-all-apply 'vla-put-textstring (list (car sel) old))
		)
	      )
	    )
	  )
	)
      )
    )

;-------------------------------------------------------------------------
; Ecriture vers Excel depuis Autocad des tableaux
;-------------------------------------------------------------------------

    (defun lecture_tableau()
      (setq old (vl-catch-all-apply
		  'vlax-get
		  (list
		    (vlax-get-property
		      (vlax-get-property classeur 'item (car lst))
		      'range
		      strsel
		    )
		    'value2
		  )
		)
      )
      (if (vl-catch-all-error-p
	    (vl-catch-all-apply
	      'vlax-put
	      (list
		(vlax-get-property
		  (vlax-get-property classeur 'item (car lst))
		  'range
		  strsel
		)
		'value2
		(unformat (vlax-invoke tab 'gettext pas col) "*")
	      )
	    )
	  )
	(progn
	  (erreur (strcat "Impossible de modifier la cellule \""
			  (cdr sel)
			  "\", de la feuille \""
			  strsel
			  "\","
		  )
	  )
	  (erreur (strcat "du fichier \""
			  (cadr tbl)
			  "\"."
		  )
	  )
	  (erreur "Verifiez par exemple que la cellule/feuille/classeur ne soit pas protg.")
	  (erreur "")
	  (setq err T)
	)
	(or (vl-catch-all-error-p old) (member ok '(0 1 4 5))
	  (vl-catch-all-apply
	    'vlax-put
	    (list
	      (vlax-get-property
		(vlax-get-property classeur 'item (car lst))
		'range
		strsel
	      )
	      'value2
	      old
	    )
	  )
	)
      )
    )

;-------------------------------------------------------------------------
; Ecriture vers Excel depuis Autocad des attributs/textes
;-------------------------------------------------------------------------

    (defun lecture_attributs()
      (setq old (vl-catch-all-apply
		  'vlax-get
		  (list
		    (vlax-get-property
		      (vlax-get-property classeur 'item (car lst))
		      'range
		      (cdr sel)
		    )
		    'value2
		  )
		)
      )
      (if (vl-catch-all-error-p
	    (vl-catch-all-apply
	      'vlax-put
	      (list
		(vlax-get-property
		  (vlax-get-property classeur 'item (car lst))
		  'range
		  (cdr sel)
		)
		'value2
		(if (eq (vla-get-objectname (car sel)) "AcDbMText")
		  (progn
		    (setq cha (unformat (vla-get-textstring (car sel)) "*"))
		    (while (vl-string-search "\\\\" cha)
		      (setq cha (vl-string-subst "\\" "\\\\" cha))
		    )
		    cha
		  )
		  (vla-get-textstring (car sel))
		)
	      )
	    )
	  )
	(progn
	  (erreur (strcat "Impossible de modifier la cellule \""
			  (cdr sel)
			  "\", de la feuille \""
			  (car lst)
			  "\","
		  )
	  )
	  (erreur (strcat "du fichier \""
			  (cadr tbl)
			  "\"."
		  )
	  )
	  (erreur "Verifiez par exemple que la cellule/feuille/classeur ne soit pas protg.")
	  (erreur "")
	  (setq err T)
	)
	(or (vl-catch-all-error-p old) (member ok '(0 1 4 5))
	  (vl-catch-all-apply
	    'vlax-put
	    (list
	      (vlax-get-property
		(vlax-get-property classeur 'item (car lst))
		'range
		(cdr sel)
	      )
	      'value2
	      old
	    )
	  )
	)
      )
    )

;-------------------------------------------------------------------------
; Ecriture depuis Excel vers Autocad des rtexts
;-------------------------------------------------------------------------

    (defun ecriture_rtext()
      (erreur (strcat "\nPas de mise  jour possible d'un Rtext affect  la cellule \""
		      (substr (cdr sel) 2)
		      "\"\nde la feuille \""
		      (car lst)
		      "\","
	      )
      )
      (erreur (strcat "du fichier \""
		      (cadr tbl)
		      "\"."
	      )
      )
      (erreur "")
    )

;-------------------------------------------------------------------------
; Ecriture vers Excel depuis Autocad des rtexts
;-------------------------------------------------------------------------

    (defun lecture_rtext()
      (setq rep (cdr sel) err nil)
      (if (or (and (> (vl-string-elt rep 2) 64) (< (vl-string-elt rep 2) 91))
	  (and (> (vl-string-elt rep 2) 96) (< (vl-string-elt rep 2) 123)))
	(setq deb (substr rep 2 2) fin (atoi (substr rep 4)))
	(setq deb (substr rep 2 1) fin (atoi (substr rep 3)))
      )
      (if (vl-string-search "$(xrefs" (cdr (assoc 1 (entget (car sel)))))
	(vlax-for der (vla-get-blocks (vla-get-activedocument (vlax-get-acad-object)))
	  (if (eq (vla-get-isxref der) :vlax-true)
	    (setq rxt (append rxt (list (vla-get-path der))))
	  )
	)
	(setq rxt (list (menucmd (strcat "M=" (cdr (assoc 1 (entget (car sel))))))))
      )
      (foreach txt rxt
	(setq old (vl-catch-all-apply
		    'vlax-get
		    (list
		      (vlax-get-property
			(vlax-get-property classeur 'item (car lst))
			'range
			(strcat deb (itoa fin))
		      )
		      'value2
		    )
		  )
	)
	(if (vl-catch-all-error-p
	      (vl-catch-all-apply
		'vlax-put
		(list
		  (vlax-get-property
		    (vlax-get-property classeur 'item (car lst))
		   'range
		   (strcat deb (itoa fin))
		  )
		  'value2
		  txt
		)
	      )
	    )
	  (progn
	    (erreur (strcat "\nImpossible de modifier la cellule \""
			    deb
			    (itoa fin)
			    "\", de la feuille \""
			    (car lst)
			    "\","
			   )
	    )
	    (erreur (strcat "du fichier \""
			    (cadr tbl)
			    "\"."
		    )
	    )
	    (erreur "Verifiez par exemple que la cellule/feuille/classeur ne soit pas protg.")
	    (erreur "")
	    (setq err T)
	  )
	  (or (vl-catch-all-error-p old) (member ok '(0 1 4 5))
	    (vl-catch-all-apply
	      'vlax-put
	      (list
		(vlax-get-property
		  (vlax-get-property classeur 'item (car lst))
		 'range
		 (strcat deb (itoa fin))
		)
		'value2
		old
	      )
	    )
	  )
	)
	(if (eq (substr rep 1 1) "2")
	  (setq fin (1+ fin))
	  (setq deb (incsuff deb 1 T))
	)
      )
      (or err (setq tai (1+ tai)))
      (setq err nil)
    )

;-------------------------------------------------------------------------
; Routine de mise  jour
;-------------------------------------------------------------------------

    (setq pos position_fichier_excel inc 0 tot 0 tai 0 lst_err nil)
    (if (eval 'acet-ui-progress-done)
      (setq express T)
    )
    (foreach tbl (vlax-ldata-list cle)
      (foreach lst (cddr tbl)
	(setq tot (+ tot (length (cdr lst))))
      )
    )
    (if express
      (acet-ui-progress-init "Traitement" tot)
    )
    (and (member ok '(0 1))
      (new_dialog "err2" lxl_dia "")
    )
    (and (member ok '(2 3))
      (new_dialog "err1" lxl_dia "")
    )
    (cond
      ((= ok 0)
        (set_tile "titre" "Rapport de la mise  jour vers Excel")
      )
      ((= ok 1)
        (set_tile "titre" "Rapport de la mise  jour vers Autocad")
      )
      ((= ok 2)
        (set_tile "titre" "Rapport de vrification des donnes vers Excel avant VALIDATION de la mise  jour")
      )
      ((= ok 3)
        (set_tile "titre" "Rapport de vrification des donnes vers Autocad avant VALIDATION de la mise  jour")
      )
    )
    (erreur "Traitement en cours...")
    (foreach tbl (reverse (vlax-ldata-list cle))
      (if (findfile (cadr tbl))
	(progn
	  (setq position_fichier_excel (car tbl))
	  (verifier_excel)
	  (foreach lst (cddr tbl)
	    (setq tst nil)
	    (vlax-for feu classeur
	      (if (eq (strcase (vlax-get feu 'name)) (strcase (car lst)))
		(setq tst T)
	      )
	    )
	    (if tst
	      (foreach sel (cdr lst)
		(if (and (car sel)
			 (vlax-read-enabled-p (car sel))
		    )
		  (if (eq (type (car sel)) 'VLA-OBJECT)
		    (if (verifier_att (car sel))
		      (progn
			(erreur (strcat "Impossible de traiter l'Attribut/Texte/Mtext/Tableau affect  la cellule \""
					(cdr sel)
					"\", de la feuille \""
					(car lst)
					"\","
				)
			)
			(erreur (strcat "du fichier \"" (cadr tbl) "\"."))
			(erreur "")
		      )
		      (progn
			(setq cha nil err nil)
			(cond
			  ((and (eq (vla-get-objectname (car sel)) "AcDbTable") (not (eq position_maj_excel 2)))
			    (setq tab (car sel)
				  cel (cdr sel)
				  tot (+ tot (* (vla-get-rows tab) (vla-get-columns tab)))
			    )
			    (if (eq (vla-get-titlesuppressed tab) :vlax-true)
			      (setq pas 0)
			      (setq pas 1 tot (- tot (vla-get-columns tab)))
			    )
			    (while (< pas (vla-get-rows tab))
			      (setq col 0 txt nil strsel cel)
			      (while (< col (vla-get-columns tab))
				(or fus
				  (if (member ok '(1 3 5))
				    (ecriture_tableau)
				    (lecture_tableau)
				  )
				)
				(if (or (and (> (vl-string-elt strsel 1) 64) (< (vl-string-elt strsel 1) 91))
					(and (> (vl-string-elt strsel 1) 96) (< (vl-string-elt strsel 1) 123))
				    )
				  (setq deb (substr strsel 1 2) fin (atoi (substr strsel 3)))
				  (setq deb (substr strsel 1 1) fin (atoi (substr strsel 2)))
				)
				(or err fus (setq tai (1+ tai)))
				(setq col (1+ col)
				      strsel (strcat (incsuff deb 1 T) (itoa fin))
				      err nil
				      fus nil
				)
			      )
			      (if (or (and (> (vl-string-elt cel 1) 64) (< (vl-string-elt cel 1) 91))
				      (and (> (vl-string-elt cel 1) 96) (< (vl-string-elt cel 1) 123))
				  )
				(setq deb (substr cel 1 2) fin (atoi (substr cel 3)))
				(setq deb (substr cel 1 1) fin (atoi (substr cel 2)))
			      )
			      (setq pas (1+ pas)
				    cel (strcat deb (itoa (1+ fin)))
			      )
			    )
			  )
			  ((and (not (eq (vla-get-objectname (car sel)) "AcDbTable")) (not (eq position_maj_excel 3)))
			    (if (member ok '(1 3 5))
			      (ecriture_attributs)
			      (lecture_attributs)
			    )
			  )
			  (T
			    (setq err T)
			  )
			)
			(or err (setq tai (1+ tai)))
		      )
		    )
		    (if (and (member ok '(0 2 4)) (not (eq position_maj_autocad 3)))
		      (lecture_rtext)
		      (if (and (not (eq position_maj_autocad 3)) (not (eq position_maj_excel 3)))
			(ecriture_rtext)
		      )
		    )
		  )
		  (progn
		    (erreur (strcat "Impossible de traiter l'objet affect  la cellule \""
				    (if (eq (type (car sel)) 'ENAME)
				      (substr (cdr sel) 2)
				      (cdr sel)
				    )
				    "\", de la feuille \""
				    (car lst)
				    "\","
			    )
		    ) 
		    (erreur (strcat "du fichier \""
				    (cadr tbl)
				    "\"."
			    )
		    )
		    (erreur "")
		  )
		)
		(if express
		  (progn
		    (setq inc (1+ inc))
		    (acet-ui-progress-safe inc)
		  )
		)
	      )
	      (progn
		(erreur (strcat "La feuille \""
				(car lst)
				"\" du fichier \""
				(vl-filename-base (cadr tbl))
				(vl-filename-extension (cadr tbl))
				"\" est introuvable."
			)
		)
		(erreur "Soit elle a t renomme ou supprime.")
		(erreur "")
		(if express
		  (progn
		    (setq inc (+ inc (length (cdr lst))))
		    (acet-ui-progress-safe inc)
		  )
		)
	      )
	    )
	  )
	  (and (not (member (strcase (vlax-get xls 'fullname)) liste_fichiers_ouvert))
	       (member ok '(0 4))
	       (vl-catch-all-error-p (vl-catch-all-apply 'vlax-invoke-method (list xls 'save)))
	    (progn
	      (erreur (strcat "Impossible de modifier le fichier \""
			      (vlax-get xls 'fullname)
			      "\"."
		      )
	      )
	      (erreur "Vrifiez par exemple qu'il n'est pas en lecture seule ou utilis par quelqu'un d'autre.")
	      (erreur "")
	    )
	  )
	)
	(progn
	  (erreur (strcat "Le fichier \""
			  (vl-filename-base (cadr tbl))
			  (vl-filename-extension (cadr tbl))
			  "\" est introuvable."
		  )
	  )
	  (erreur (strcat "Soit il a t renomm, supprim ou dplac du rpertoire \""
			  (vl-filename-directory (cadr tbl))
			  "\"."
		  )
	  )
	  (erreur "")
	  (if express
	    (progn
	      (foreach lst (cddr tbl)
		(setq inc (+ inc (length (cdr lst))))
	      )
	      (acet-ui-progress-safe inc)
	    )
	  )
	)
      )
    )
    (if express
      (acet-ui-progress-done)
    )
    (setq position_fichier_excel pos)
    (if (member ok '(0 1 2 3))
      (progn
	(erreur (strcat "Traitement de " (itoa tai) " Objet(s) sur " (itoa tot) "."))
	(mode_tile "cancel" 2)
	(action_tile "valid"  "(done_dialog 1)")
	(action_tile "accept" "(done_dialog 0)")
	(action_tile "cancel" "(done_dialog 0)")
	(if (= (start_dialog) 1)
	  T
	  nil
	)
      )
      (progn
	(princ (strcat "\nTraitement de " (itoa tai) " Objet(s) sur " (itoa tot) "."))
	nil
      )
    )
  )

;-------------------------------------------------------------------------
; Choix des blocs  traiter dans les racteurs
;-------------------------------------------------------------------------

  (defun selection_blocs(/ bl lst lstbl res sel trie)
    (setq bl (tblnext "block" t))
    (while bl
      (or (not (zerop (logand (cdr (assoc 70 bl)) (+ 1 4 16))))
	(zerop (logand (cdr (assoc 70 bl)) 2))
	(member (cdr (assoc 2 bl)) lst)
	(setq lst (cons (cdr (assoc 2 bl)) lst))
      )
      (setq bl (tblnext "block"))
    )
    (if lst
      (progn
	(setq lst (acad_strlsort lst) sel "")
	(if (setq bl (vlax-ldata-get (strcat cle "_params") "Params"))
	  (progn
	    (while bl
	      (setq sel (strcat sel " " (itoa (- (length lst) (length (member (car bl) lst)))))
		    bl (cdr bl)
	      )
	    )
	    (setq sel (substr sel 2))
	  )
	)
	(new_dialog "bloc" lxl_dia "")
	(start_list "valeur")
	(mapcar 'add_list lst)
	(end_list)
	(set_tile "valeur" sel)
	(mode_tile "cancel" 2)
	(action_tile "valeur" "(setq sel $value)")
	(action_tile "accept" "(done_dialog 1)")
	(action_tile "cancel" "(done_dialog 0)")
	(if (eq (start_dialog) 1)
	  (progn
	    (while (not (eq sel ""))
	      (setq lstbl (cons (nth (setq bl (read sel)) lst) lstbl)
		    sel (substr sel (+ 2 (strlen (itoa bl))))
	      )
	    )
	    (if lstbl
	      (vlax-ldata-put (strcat cle "_params") "Params" (reverse lstbl))
	      (vlax-ldata-delete (strcat cle "_params") "Params")
	    )
	  )
	)
      )
      (msgbox "LXL" 48 "Pas de blocs avec attributs dans le dessin.")
    )
  )

;-------------------------------------------------------------------------
; Griser ou pas le bouton trier
;-------------------------------------------------------------------------

(defun affiche_trier(ok / lst)
  (if (and (vlax-ldata-list cle)
	   ok
	   position_fichier_excel
	   position_feuille_excel
	   (setq lst (cdr (nth (1+ (atoi position_feuille_excel)) (vlax-ldata-get cle position_fichier_excel))))
	   (> (length lst) 1)
      )
    (mode_tile "trier" 0)
    (mode_tile "trier" 1)
  )
)

;-------------------------------------------------------------------------
; Trier les attributs par ordre croissant
;-------------------------------------------------------------------------

(defun trier_attributs(/ lst1 lst2 lst3 trier_att)

  (defun trier_att(lst col / 6ch bl ch6 lst1 lst2 lst3 lst4 lst5 rech_id)

    (defun rech_id(obj / val)
      (if (and 	obj
		(not (eq (type obj) 'ENAME))
		(eq  (vla-get-objectname obj) "AcDbAttribute")
		(not (vl-catch-all-error-p (setq val (vl-catch-all-apply 'vla-objectidtoobject (list (vla-get-database obj)(vla-get-ownerid obj))))))
	  )
	val
	nil
      )
    )

    (defun 6ch(str col / deb fin)
      (if (< (ascii (substr str 2 1)) 58)
	(setq deb (substr str 1 1)
	      fin (substr str 2)
	)
	(setq deb (substr str 1 2)
	      fin (substr str 3)
	)
      )
      (while (< (strlen fin) 6)
	(setq fin (strcat "0" fin))
      )
      (if col
	(strcat (strcase deb) fin)
	(strcat fin (strcase deb))
      )
    )

    (defun ch6(str col / deb fin)
      (if col
	(if (< (ascii (substr str 2 1)) 58)
	  (setq deb (substr str 1 1)
		fin (substr str 2)
	  )
	  (setq deb (substr str 1 2)
		fin (substr str 3)
	  )
	)
	(setq deb (substr str 7)
	      fin (substr str 1 6)
	)
      )
      (strcat deb (itoa (atoi fin)))
    )

    (setq lst1 (mapcar '(lambda (x) (list (rech_id (car x)) (car x) (6ch (cdr x) col))) lst))
    (while lst1
      (setq lst2 (list (cdar lst1))
	    lst3 (cdr lst1)
      )
      (foreach bl (cdr lst1)
	(if (and (car bl) (caar lst1) (eq (vla-get-objectid (caar lst1)) (vla-get-objectid (car bl))))
	  (setq lst2 (cons (cdr bl) lst2)
		lst3 (vl-remove bl lst3)
	  )
	)
      )
      (setq lst1 lst3
	    lst4 (cons lst2 lst4)
      )
    )

    (setq lst1 (vl-sort (mapcar '(lambda (x) (vl-sort x '(lambda (a b) (< (cadr a) (cadr b))))) lst4) '(lambda (a b) (< (cadar a) (cadar b)))))
    (foreach bl lst1 (setq lst5 (append lst5 bl)))
    (mapcar '(lambda(x) (cons (car x) (ch6 (cadr x) col))) lst5)
  )

  (setq lst1 (nth (1+ (atoi position_feuille_excel)) (vlax-ldata-get cle position_fichier_excel)))
  (if (= position_saisie_excel 2)
    (setq lst2 (trier_att (cdr lst1) nil))
    (setq lst2 (trier_att (cdr lst1) T))
  )
  (vlax-ldata-put cle position_fichier_excel (subst (cons (car lst1) lst2) lst1 (vlax-ldata-get cle position_fichier_excel)))
  (affiche_attributs lst2)
  (setq position_att_excel "0")
  (set_tile "valeur" "")
  (set_tile "valeur" position_att_excel)
  (affiche_attribut)
  (haut_bas)
)

;-------------------------------------------------------------------------
; Griser ou pas le bouton changer
;-------------------------------------------------------------------------

(defun affiche_changer()
  (if (and position_fichier_excel
	   position_feuille_excel
	   (> (length (cdr (vlax-ldata-get cle position_fichier_excel))) 1)
	   (cdr (nth (1+ (atoi position_feuille_excel)) (vlax-ldata-get cle position_fichier_excel)))
      )
    (mode_tile "change" 0)
    (mode_tile "change" 1)
  )
)

;-------------------------------------------------------------------------
; Changer des attributs de feuille Excel
;-------------------------------------------------------------------------

(defun changer_feuille_att(/ act bas dest destf lec lst n orig pos res tbl val)
  (setq pos "0"	n 0)
  (new_dialog "lxl" lxl_dia "")
  (start_list "feuille")
  (foreach bas (cdr (vlax-ldata-get cle position_fichier_excel))
    (if (/= (atoi position_feuille_excel) n)
      (progn
	(setq lst (cons (cons n (car bas)) lst))
	(add_list (car bas))
      )
    )
    (setq n (1+ n))
  )
  (end_list)
  (set_tile "feuille" pos)
  (mode_tile "feuille" 2)
  (action_tile "feuille" "(setq pos $value)")
  (action_tile "accept"  "(done_dialog 1)")
  (action_tile "cancel"  "(done_dialog 0)")
  (setq res (start_dialog))
  (and (= res 1)
    (progn
      (setq orig (nth (1+ (atoi position_feuille_excel)) (vlax-ldata-get cle position_fichier_excel))
      	    dest (nth (1+ (car (nth (atoi pos) (reverse lst)))) (vlax-ldata-get cle position_fichier_excel))
	    n 0
      )
      (while (setq lec (nth n (cdr orig)))
	(if (recherche_valeur n position_att_excel)
	  (setq val (append val (list lec)))
	)
	(setq n (1+ n))
      )
      (setq destf (cons (car dest) (append (cdr dest) val))
	    destf (subst destf dest (vlax-ldata-get cle position_fichier_excel))
      )
      (vlax-ldata-put cle position_fichier_excel destf)
      (supprimer_attribut)
    )
  )
)

;-------------------------------------------------------------------------
; Routine principale
;-------------------------------------------------------------------------

  (vl-load-com)
  (vla-startundomark (vla-get-activedocument (vlax-get-acad-object)))
  (setq cle "Patrick_35_Excel")
  (or activation_reacteurs_lxl
    (setq activation_reacteurs_lxl "0")
  )
  (if (setq lxl_dia (findfile "lxl.dcl"))
    (progn
      (setq lxl_dia (load_dialog lxl_dia))
      (while (and (not (member res '(0 7 8 9 10))))
	(new_dialog "att" lxl_dia "")
	(gestion_affichage_boite nil)
	(affiche_changer)
	(if (eq position_saisie_excel 1)
	  (affiche_trier nil)
	  (affiche_trier T)
	)
	(set_tile "acti" activation_reacteurs_lxl)
	(set_tile "accept" "2")
	(action_tile "fichier"	"(position_fichier $value)")
	(action_tile "afichier"	"(done_dialog 1)")
	(action_tile "sfichier"	"(supprimer_fichier)")
	(action_tile "cfichier"	"(done_dialog 2)")
	(action_tile "feuille"	"(position_feuille $value)")
	(action_tile "afeuille"	"(done_dialog 3)")
	(action_tile "sfeuille"	"(supprimer_feuille)")
	(action_tile "cfeuille"	"(done_dialog 4)")
	(action_tile "valeur"	"(position_attribut $value)")
	(action_tile "aatt1"	"(done_dialog 5)")
	(action_tile "aatt2"	"(done_dialog 6)")
	(action_tile "libre"	"(setq position_saisie_excel 1)(affiche_trier nil)")
	(action_tile "ligne"	"(setq position_saisie_excel 2)(affiche_trier T)")
	(action_tile "colonne"	"(setq position_saisie_excel 3)(affiche_trier T)")
	(action_tile "satt"	"(supprimer_attribut)")
	(action_tile "matt"	"(modifier_attributs)")
	(action_tile "change"	"(changer_feuille_att)")
	(action_tile "trier"	"(trier_attributs)")
	(action_tile "maj1"	"(done_dialog 7)")
	(action_tile "maj2"	"(done_dialog 8)")
	(action_tile "maj3"	"(done_dialog 9)")
	(action_tile "maj4"	"(done_dialog 10)")
	(action_tile "toutae"	"(setq position_maj_autocad 1)")
	(action_tile "attae"	"(setq position_maj_autocad 2)")
	(action_tile "tabae"	"(setq position_maj_autocad 3)")
	(action_tile "toutea"	"(setq position_maj_excel 1)")
	(action_tile "attea"	"(setq position_maj_excel 2)")
	(action_tile "tabea"	"(setq position_maj_excel 3)")
	(action_tile "haut"	"(trier_attributs_haut)")
	(action_tile "bas"	"(trier_attributs_bas)")
	(action_tile "acti"	"(setq activation_reacteurs_lxl $value)")
	(action_tile "choix"	"(done_dialog 11)")
	(action_tile "accept"	"(done_dialog 0)")
	(action_tile "cancel"	"(done_dialog 0)")
	(setq res (start_dialog))
	(cond
	  ((eq res 1)
	    (ajouter_fichier)
	  )
	  ((eq res 2)
	    (changer_fichier)
	  )
	  ((eq res 3)
	    (ajouter_feuille)
	  )
	  ((eq res 4)
	    (changer_feuille)
	  )
	  ((eq res 5)
	    (ajouter_attributs T)
	  )
	  ((eq res 6)
	    (ajouter_attributs nil)
	  )
	  ((eq res 7)
	    (mise_a_jour 0)
	  )
	  ((eq res 8)
	    (mise_a_jour 1)
	  )
	  ((eq res 9)
	    (and (mise_a_jour 2)(mise_a_jour 4))
	  )
	  ((eq res 10)
	    (and (mise_a_jour 3)(mise_a_jour 5))
	  )
	  ((eq res 11)
	    (selection_blocs)
	  )
	)
      )
      (unload_dialog lxl_dia)
    )
    (msgbox "LXL" 16 "Fichier LXL.DCL introuvable.")
  )
  (if xl
    (fermer_excel)
  )
  (if reacteur_lxl
    (and (eq activation_reacteurs_lxl "0")
      (patrick:effacer_le_reacteur_lxl)
      (setq reacteur_lxl nil)
    )
    (and (eq activation_reacteurs_lxl "1")
      (patrick:effacer_le_reacteur_lxl)
      (setq reacteur_lxl (vlr-acdb-reactor cle (list (cons :vlr-objectappended (function patrick:reacteur_lxl)))))
      (vlr-command-reactor nil (list (cons :vlr-commandwillstart (function patrick:annuler_adcenter))))
    )
  )
  (vla-endundomark (vla-get-activedocument (vlax-get-acad-object)))
  (princ)
)

(setq nom_lisp "LXL")
(if (/= app nil)
  (if (= (strcase (substr app (1+ (- (strlen app) (strlen nom_lisp))) (strlen nom_lisp))) nom_lisp)
    (princ (strcat "..." nom_lisp " charg."))
    (princ (strcat "\n" nom_lisp ".LSP Charg.....Tapez " nom_lisp " pour l'xecuter.")))
  (princ (strcat "\n" nom_lisp ".LSP Charg......Tapez " nom_lisp " pour l'xecuter.")))
(setq nom_lisp nil)
(princ)